/* GTK - The GIMP Toolkit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

/* Backing pixmap for drawing area */
static GdkPixmap *pixmap = NULL;

/* Create a new backing pixmap of the appropriate size */
static gint
configure_event (GtkWidget *widget, GdkEventConfigure *event)
{
  if (pixmap)
    gdk_pixmap_unref(pixmap);

  pixmap = gdk_pixmap_new(widget->window,
			  widget->allocation.width,
			  widget->allocation.height,
			  -1);
  gdk_draw_rectangle (pixmap,
		      widget->style->white_gc,
		      TRUE,
		      0, 0,
		      widget->allocation.width,
		      widget->allocation.height);

  return TRUE;
}

/* Redraw the screen from the backing pixmap */
static gint
expose_event (GtkWidget *widget, GdkEventExpose *event)
{
  gdk_draw_pixmap(widget->window,
		  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		  pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);

  return FALSE;
}

/*
** Draw the wav for start:
*/

static void draw_wav(GtkWidget *widget)          
{
  GdkSegment seg;
  GdkRectangle rec;
  int i, j;
  //------------------------------------------
  GdkColor Color; 
  
  Color.red = 0; 
  Color.green = 20000; 
  Color.blue = 65000; 
  
  gdk_color_alloc (gdk_window_get_colormap (DrawingArea->window), 
		   &Color); 
  
  gdk_window_set_background (DrawingArea->window, &Color); 
  
  gc = gdk_gc_new( DrawingArea->window ); 
  
  gdk_gc_set_background( gc, &Color ); 
  
  BackPixmap = gdk_pixmap_new(DrawingArea->window, 
			      DrawingArea->allocation.width, 
			      DrawingArea->allocation.height, 
			      -1); 
  
  gdk_draw_pixmap( BackPixmap, 
		   gc, 
		   DrawingArea->window, 
		   0,0,0,0, 
		   DrawingArea->allocation.width, 
		   DrawingArea->allocation.height ); 

  // --------------------------------------------------

  GtkWidget *gbutton;  
  gbutton = gtk_toggle_button_new(); 
                     GTk_STATE_NORMAL  
  gbutton->style->bg[GTK_STATE_ACTIVE].green=0; 
  gbutton->style->bg[GTK_STATE_ACTIVE].blue=0; 
  gtk_widget_show(gbutton); 
  
   !!!! set_style

	  // ------------------------------------

  GdkColor mycolor; 

  gdk_color_parse("green", &mycolor); parse le fichier rgb.txt.
  gdk_color_alloc(gtk_widget_get_colormap(widget), &mycolor); 

  // ------------------------------------

  int main (int argc, char *argv[]) 
    { 
      GtkWidget *window; 
      GtkWidget *drawing_area; 
      GtkWidget *pixmap; 
      GdkPixmap *gdkpixmap; 
      GtkStyle *style; 
      GdkBitmap *mask; 
      gchar *mask_data; 
      int i; 
      
      piccy = read_jpeg("test.jpg"); 
      gtk_init (&argc, &argv); 
      window = gtk_window_new (GTK_WINDOW_TOPLEVEL); 
      gtk_window_set_title(GTK_WINDOW (window), "Test Piccy"); 
      mask_data = g_malloc( sizeof(char) * piccy->height *  piccy->width); 
      mask = gdk_bitmap_create_from_data(window->window, mask_data, 
					 piccy->width, piccy->height); 
      style = gtk_widget_get_style (window); 
      gdkpixmap = gdk_pixmap_create_from_data(NULL, piccy->Image, 
					      piccy->width, piccy->height, -1, 
					      style->fg, &style->black); 
      pixmap = gtk_pixmap_new (gdkpixmap, NULL); 
      gtk_signal_connect(GTK_OBJECT(window), "delete_event", 
			 GTK_SIGNAL_FUNC(delete_event), NULL); 
      gtk_container_add(GTK_CONTAINER(window), pixmap); 
      gtk_widget_show (pixmap); 
      gtk_widget_show (window); 
      gtk_main(); 
      return 0; 
    } 

 // -----------------------------------------

  gtk_widget_set_uposition (); 
  should work. 

  // ---------------------------------------


  gdk_rgb
    gdk_imlib
  
   GdkColor c;      
   GtkStyle *style; 
   GtkWidget *time; 
   time = gtk_entry_new(); 
   c.red = 0; 
   c.green = 0xffff; 
   c.blue = 0; 
   gdk_color_alloc (gtk_widget_get_colormap (time), &c); 
   style = gtk_style_copy (gtk_widget_get_style (time)); 
   style->text[GTK_STATE_NORMAL] = c; 
   style->fg[GTK_STATE_NORMAL] = c; 
   gdk_font_unref (style->font); 
   style->font = gdk_font_load 
     ("-adobe-helvetica-bold-r-normal-*-*-240-*-*-p-*-iso8859-1"); 
   c.red = 0; 
   c.green = 0; 
   c.blue = 0; 
   gdk_color_alloc (gtk_widget_get_colormap (time), &c); 
   style->bg[GTK_STATE_NORMAL] = c; 
   style->base[GTK_STATE_NORMAL] = c; 
   gtk_widget_set_style(time, style); 
   gtk_entry_set_text(GTK_ENTRY (time), "[0] 00:00.00"); 
     
  // -------------------------------------

  time = gtk_entry_new (); 
  style = gtk_style_new (); 
  style->font = gdk_font_load 
    ("-adobe-helvetica-bold-r-normal-*-*-240-*-*-p-*-iso8859-1"); 
  style->text[GTK_STATE_NORMAL].red = 0; 
  style->text[GTK_STATE_NORMAL].green = 1; 
  style->text[GTK_STATE_NORMAL].blue = 0; 
  style->bg[GTK_STATE_NORMAL] = style->black; 
  gtk_widget_set_style (time, style); 


  //------------------------------------------------------

  rec.x = 0;
  rec.y = 0;
  rec.width = widget->allocation.width ;
  rec.height = widget->allocation.height ;
  seg.y1 = 100;
  for (i = 0; i < 500; i += 2)
    {
      seg.y2 =  (rand() % 200) ;
      for (j=i ; j < i+2; j++)
	{
	  seg.x1 = (seg.x2 = j);
	  gdk_draw_segments(pixmap,
			    widget->style->black_gc,
			    &seg,
			    1);
    
	}
    }
  
  gtk_widget_draw(widget, &rec);
}


/* Draw a rectangle on the screen */
static void
draw_brush(GtkWidget *widget, gdouble x, gdouble y)
{
  GdkRectangle update_rect;

  update_rect.x = x - 5;
  update_rect.y = y - 5;
  update_rect.width = 10;
  update_rect.height = 10;
  gdk_draw_rectangle(pixmap,
		     widget->style->black_gc,
		     TRUE,
		     update_rect.x, update_rect.y,
		     update_rect.width, update_rect.height);
  gtk_widget_draw(widget, &update_rect);
}

static gint
button_press_event(GtkWidget *widget, GdkEventButton *event)
{
  if (event->button == 1 && pixmap != NULL)
    draw_wav(widget);
  
    /*
    **draw_brush(widget, event->x, event->y);
    */
  return TRUE;
}

static gint
motion_notify_event(GtkWidget *widget, GdkEventMotion *event)
{
  int x, y;
  GdkModifierType state;

  if (event->is_hint)
    gdk_window_get_pointer(event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;
      state = event->state;
    }
    
  if (state & GDK_BUTTON1_MASK && pixmap != NULL)
    draw_brush(widget, x, y);
  
  return TRUE;
}

void
quit ()
{
  gtk_exit (0);
}

int
main (int argc, char *argv[])
{
  GtkWidget *window;
  GtkWidget *drawing_area;
  GtkWidget *vbox;

  GtkWidget *button;

  gtk_init (&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (window, "Test Input");

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window), vbox);
  gtk_widget_show (vbox);

  gtk_signal_connect (GTK_OBJECT (window), "destroy",
		      GTK_SIGNAL_FUNC (quit), NULL);

  /* Create the drawing area */

  drawing_area = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area), 200, 200);
  gtk_box_pack_start (GTK_BOX (vbox), drawing_area, TRUE, TRUE, 0);

  gtk_widget_show (drawing_area);

  /* Signals used to handle backing pixmap */

  gtk_signal_connect (GTK_OBJECT (drawing_area), "expose_event",
		      (GtkSignalFunc) expose_event, NULL);
  gtk_signal_connect (GTK_OBJECT(drawing_area),"configure_event",
		      (GtkSignalFunc) configure_event, NULL);

  /* Event signals */

  gtk_signal_connect (GTK_OBJECT (drawing_area), "motion_notify_event",
		      (GtkSignalFunc) motion_notify_event, NULL);
  gtk_signal_connect (GTK_OBJECT (drawing_area), "button_press_event",
		      (GtkSignalFunc) button_press_event, NULL);

  gtk_widget_set_events (drawing_area, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);

  /* .. And a quit button */
  button = gtk_button_new_with_label ("Quit");
  gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);

  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (window));
  gtk_widget_show (button);

  gtk_widget_show (window);

  gtk_main ();

  return 0;
}
